Subject: Re: bug#57082: 29.0.50; emacs-news-view-mode breakage

From: Stephen Berman <[email-masked]>
Date: Wed, 10 Aug 2022 20:58:03 +0200

On Wed, 10 Aug 2022 21:45:25 +0300 Juri Linkov <[email-masked]> wrote:

>>>>> `outline-minor-mode-highlight-buffer' is intended only for buffers
>>>>> that don't support font-lock highlighting.
>>>>
>>>> Yes, but with that change, arrows are displayed on first visiting the
>>>> NEWS buffer; without it, they only appear when typing TAB on an outline
>>>> heading.
>>>
>>> This change broke fontification e.g. in diff buffers that now
>>> add outline faces on diff hunks.  So we need another solution.
>>
>> Oh, dear (as I noted in my OP, I only checked NEWS and *Help* with
>> describe-binding).  But do you have a recipe to see this?  When I create
>> a diff with vc-diff I don't see outline faces on the hunks.
>
> The minimal test case is this:
>
>   (setq-default outline-minor-mode-highlight t)
>   (add-hook 'diff-mode-hook 'outline-minor-mode)
>
> Then the first lines of diff is highlighted with blue outline-1 face,
> the @@-lines with outline-2 face, etc.

Yes, I see it now, thanks.

> This is because outline-font-lock-keywords and
> outline-minor-mode-highlight-buffer have slightly different
> interpretations of the values for outline-minor-mode-highlight.
>
> This could be improved, but in any case both these functions
> should not be applied at the same time.

Ok.  I'm not familiar enough with the intricacies of font-lock to whip
up a quick fix and can't afford to spend a lot of time on it, so I hope
someone better qualified than me will do it.

Steve Berman